local ns = CreateFrame("Frame", nil) -- sets up a namespace so we don't have to worry about globals anymore
local version = 131 -- Version number!
------------------------------------------------------------------
------------------------------------------------------------------
--ALL VARIABLE DECLARATION SHOULD GO HERE (Aside from internal function declarations)
ns.byName = {
	["Alterac Valley"] = {
		uid = 1,
		total = 53,
		won = 49,
		icon = "Interface\\Icons\\Achievement_Zone_DunMorogh",
	},
	["Warsong Gulch"] = {
		uid = 2,
		total = 52,
		won = 105,
		icon = "Interface\\Icons\\Achievement_Zone_Ashenvale_01",
	},
	["Arathi Basin"] = {
		uid = 3,
		total = 55,
		won = 51,
		icon = "Interface\\Icons\\Achievement_Zone_ArathiHighlands_01",
	},
	["Eye of the Storm"] = {
		uid = 7,
		total = 54,
		won = 50,
		icon = "Interface\\Icons\\Achievement_Zone_Netherstorm_01",
	},
	["Strand of the Ancients"] = {
		uid = 9,
		total = 1549,
		won = 1550,
		icon = "Interface\\Icons\\Achievement_BG_WinSoA",
	},
	["Isle of Conquest"] = {
		uid = 30,
		total = 4096,
		won = 4097,
		icon = "Interface\\Icons\\Achievement_Zone_BoreanTundra_01",
	},
	["Random Battleground"] = {
		uid = 32,
		icon = "Interface\\Icons\\INV_Misc_QuestionMark",
	},
	["Twin Peaks"] = {
		uid = 108,
		total = 5232,
		won = 5233,
		icon = "Interface\\Icons\\Achievement_Zone_TwilightHighlands",
	},
	["The Battle for Gilneas"] = {
		uid = 120,
		total = 5236,
		won = 5237,
		icon = "Interface\\Icons\\Achievement_Battleground_BattleForGilneas",
	},

	["Wintergrasp"] = {
		uid = 1,
		icon = "",
		icon = "",
		isWorld = true,
		queueReady = 15*60,
		icon = "Interface\\Icons\\Achievement_Zone_DragonBlight_09",
	},
	["Tol Barad"] = {
		uid = 21,
		icon = "Interface\\Icons\\Achievement_Zone_TolBarad",
		isWorld = true,
		queueReady = 15*60,
	},
}
ns.n_Settings_proper = {
		login = {
			enabled = true,
			text = "Login",
		},
		logout= {
			enabled = true,
			text = "Logout",
		},
		battleground= {
			enabled = true,
			text = "Battlegrounds",
		},
		achievement = {
			enabled = true,
			text = "Achievement",
		},
		levelup = {
			enabled = true,
			text = "Level up",
		},
		dungeons = {
			enabled = true,
			text = "LFG Dungeons/Raids",
		},
		death = {
			enabled = true,
			text = "Death",
		},
		zone = {
			enabled = true,
			text = "Zone Change",
		},
		DBM = {
			enabled = true,
			text = "DBM Boss Kills/Wipes",
		},
	}
ns.numshown, shownDateIndex, ns.displayIndex, ns.n_colors, ns.n_date, n_time, n_org, n_fin, n_sub, ns.sum_buttons = 0, 0, nil, {}, "null", "null", 0, 0, 0, {};
ns.n_colors["Druid"] = "FF7D0A";
ns.n_colors["Hunter"] = "ABD473";
ns.n_colors["Mage"] = "69CCF0";
ns.n_colors["Paladin"] = "F58CBA";
ns.n_colors["Priest"] = "FFFFFF";
ns.n_colors["Rogue"] = "FFF569";
ns.n_colors["Shaman"] = "0070DE";
ns.n_colors["Warlock"] = "9482C9";
ns.n_colors["Warrior"] = "C79C6E";
ns.n_colors["Death Knight"] = "C41F3B";
ns.n_colors["Monk"] = "00FF96";
CHARACTERFRAME_DOUBLE_EXPAND = CHARACTERFRAME_EXPANDED_WIDTH + 100;
stickyIndex, stickyDb = nil, nil;
ns.months = {
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December"
}
ns.events = {
	"ACHIEVEMENT_EARNED",
	"PLAYER_LOGIN",
	"PLAYER_LOGOUT",
	"PLAYER_LEVEL_UP",
	"ZONE_CHANGED_NEW_AREA",
	"PLAYER_DEAD",
	"ADDON_LOADED",
	"UPDATE_BATTLEFIELD_SCORE",
	"LFG_COMPLETION_REWARD"
}
ns.PvPTextures = {};
ns.PvPTextures["Alterac Valley"] = "Interface\\PVPFrame\\PvpBg-AlteracValley";
ns.PvPTextures["Warsong Gulch"] = "Interface\\PVPFrame\\PvpBg-WarsongGulch";
ns.PvPTextures["Arathi Basin"] = "Interface\\PVPFrame\\PvpBg-ArathiBasin";
ns.PvPTextures["Eye of the Storm"] = "Interface\\PVPFrame\\PvpBg-EyeOfTheStorm";
ns.PvPTextures["Strand of the Ancients"] = "Interface\\PVPFrame\\PvpBg-StrandOfTheAncients";
ns.PvPTextures["Isle of Conquest"] = "Interface\\PVPFrame\\PvpBg-IsleOfConquest";
ns.PvPTextures["Twin Peaks"] = "Interface\\PVPFrame\\PvpBg-TwinPeaks";
ns.PvPTextures["The Battle for Gilneas"] = "Interface\\PVPFrame\\PvpBg-Gilneas";
------------------------------------------------------------------
------------------------------------------------------------------
------------------------------------------------------------------
------------------------------------------------------------------
------------------------------------------------------------------
--SELF LIBRARY FUNCTIONS
local function valShort(value)
	if(value >= 1e6) then
		return ("%.2f"):format(value / 1e6):gsub("%.?0+$", "") .. "m"
	elseif(value >= 1e4) then
		return ("%.1f"):format(value / 1e3):gsub("%.?0+$", "") .. "k"
	else
		return value
	end
end
local function bubbleSort(t)
--check to make sure the table has some items in it
	if #t < 2 then
		return
	end
	local i, j;
	for i = 1, #t do --> array start to end
		for j = 2, #t do
			if (t[j]["date"]) then
				if tonumber(string.sub(t[j]["date"], 4, 5)) < tonumber(string.sub(t[j-1]["date"], 4, 5)) and tonumber(string.sub(t[j]["date"], 1, 2)) < tonumber(string.sub(t[j-1]["date"], 1, 2)) and tonumber(string.sub(t[j]["date"], 7, 8)) < tonumber(string.sub(t[j-1]["date"], 7, 8)) then
					temp = t[j-1]
					temp = t[j-1]
					t[j-1] = t[j]
					t[j] = temp
				end
			end
		end
	end
	return
end
local firstload = false;
ns.stickyIDX = 0;
function n_returnDailyIndex()
	if (n_log == nil) then
		n_log = {}
	end
	if (#n_log > 1) then
		if (ns.stickyIDX == 0) then
			for index,value in pairs(n_log) do 
				if (value["date"] == ns.n_date) then
					ns.stickyIDX = index;
					break
				end
			end
			if (firstload == false and ns.stickyIDX == 0) then
				local dateTable = {}
				dateTable["date"] = ns.n_date;
				dateTable["tt"] = 0;
				table.insert(n_log, dateTable);
				for index,value in pairs(n_log) do 
					if (value["date"] == ns.n_date) then
						ns.stickyIDX = index;
						break
					end
				end
				firstload = true;
			end
		end
	else
		if (n_log[1] == nil) then
			local dateTable = {}
			dateTable["date"] = ns.n_date;
			dateTable["tt"] = 0;
			table.insert(n_log, dateTable);
		end
		ns.stickyIDX = 1
	end
	
	return ns.stickyIDX;
end


------------------------------------------------------------------
--SUMMARY FRAME FUNCTION DECLARATIONS
function Summary_RetrieveDB(n_index, index, db)
	if (((n_index == nil) or (n_index == 0)) and (stickyIndex ~= nil)) then
		n_index = stickyIndex;
	else
		stickyIndex = n_index;
	end
	local indexedArray = {}
	local headerArray = {}
	local isHeader = false;
	if (db ~= "levels") then
		for a, z in pairs(n_log[n_index]["summary"][db]) do
			if (a ~= "count") then
				table.insert(indexedArray, a)
				for j,k in ipairs(indexedArray) do
					if (k == a) then
						table.insert(headerArray, j)
					end
				end
				if (type(z) == "table") then
					for loo, law in ipairs(z) do
						table.insert(indexedArray, law)
					end
				end
			end
		end
		for jack, jill in ipairs(headerArray) do
			if (index == jill) then
				isHeader = true;
			end
		end
	else
		for a, z in pairs(n_log[n_index]["summary"][db]) do
			if (a ~= "count") then
				table.insert(indexedArray, a .. ": " .. z)
			end
		end
		isHeader = true;
	end
	return isHeader, indexedArray[index];
end
function Summary_RetrieveDBLength(n_idx, db)
	if (((n_idx == nil) or (n_idx == 0)) and (stickyIndex ~= nil)) then
		n_idx = stickyIndex;
	else
		stickyIndex = n_idx;
	end
	local indexedArray = {}
	if (n_log[n_idx]["summary"] ~= nil) then
		if (n_log[n_idx]["summary"][db] ~= nil) then
			for a,z in pairs(n_log[n_idx]["summary"][db]) do
				table.insert(indexedArray, a)
				if (type(z) == "table") then
					for loo, law in ipairs(z) do
						table.insert(indexedArray, law)
					end
				end
			end
		end
	end
	return #indexedArray;
end
function SummaryFrame_OnLoad(self)
	SummaryContainer.update = Summary_Update;
	HybridScrollFrame_CreateButtons(SummaryContainer, "LoggerSummaryButtonTemplate", 0, 0);
end
function SummaryButton_OnEnter(self)
	SummaryContainer.activeButton = self;
	GameTooltip:Hide();
	local buttonString = self.text:GetText();
	if (_G["n_title"]:GetText() == "Items") then
		--GuildNewsButton_AnchorTooltip(self);
		-- local startPos, endPos, firstWord, restOfString = string.find(buttonString,"|Hitem:%d+:");
		-- local itemID = string.sub(buttonString,startPos+7,endPos-1);
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, 0);
		GameTooltip:SetHyperlink(buttonString);
		GameTooltip:Show();
	elseif (_G["n_title"]:GetText() == "Achievements") then
		-- local startPos, endPos, firstWord, restOfString = string.find(buttonString,"|Hachievement:%d+:");
		-- local aID = string.sub(buttonString,startPos+14,endPos-1);
		-- local achievementId = tonumber(aID);
		-- local _, name, _, _, _, _, _, description = GetAchievementInfo(achievementId);
		-- --GuildNewsButton_AnchorTooltip(self);
		-- GameTooltip:SetText(ACHIEVEMENT_COLOR_CODE..name);
		-- GameTooltip:AddLine(description, 1, 1, 1, 1);
		-- local firstCriteria = true;
		-- local leftCriteria;
		-- for i = 1, GetAchievementNumCriteria(achievementId) do
			-- local criteriaString, _, _, _, _, _, flags = GetAchievementCriteriaInfo(achievementId, i);
			-- -- skip progress bars
			-- if ( bit.band(flags, ACHIEVEMENT_CRITERIA_PROGRESS_BAR) ~= ACHIEVEMENT_CRITERIA_PROGRESS_BAR ) then
				-- if ( leftCriteria ) then
					-- if ( firstCriteria ) then
						-- GameTooltip:AddLine(" ");
						-- firstCriteria = false;
					-- end
					-- GameTooltip:AddDoubleLine(leftCriteria, criteriaString, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8);
					-- leftCriteria = nil;
				-- else
					-- leftCriteria = criteriaString;
				-- end
			-- end
		-- end
		-- -- check for leftover criteria
		-- if ( leftCriteria ) then
			-- if ( firstCriteria ) then
				-- GameTooltip:AddLine(" ");
			-- end	
			-- GameTooltip:AddLine(leftCriteria, 0.8, 0.8, 0.8);
		-- end
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, 0);
		GameTooltip:SetHyperlink(buttonString);
		GameTooltip:Show();
	end
end
function SummaryButton_OnLeave(self)
	SummaryContainer.activeButton = nil;
	GameTooltip:Hide();
end
function Summary_Update(db, idx)
	--print("1. DB is " ..tostring(db).. " and index is " ..tostring(idx));
	if (((idx == nil) or (idx == 0)) and (stickyIndex ~= nil)) then
		idx = stickyIndex;
	elseif (stickyIndex) then
		stickyIndex = idx;
	end
	if ((db == nil) or (db == "")) and (stickyDb) then
		db = stickyDb;
	else
		stickyDb = db;
	end
	
	if (db == "Achievements") then
		db = "achieves"
	elseif (db == "Items") then
		db = "items"
	elseif (db == "Levels") then
		db = "levels"
	end
	---- print(db);
	local scrollFrame, offset, buttonss, button, index;
	--local numGuildNews = GetNumGuildNews();
	scrollFrame = SummaryContainer;
	offset = HybridScrollFrame_GetOffset(scrollFrame);
	--print("Offset: " .. offset)
	buttonss = scrollFrame.buttons;
	numButtons = #buttonss;
	for i = 1, numButtons do
		button = buttonss[i];
		index = offset + i;
		if ( index <= (Summary_RetrieveDBLength(idx, db)-1) ) then
			--local isSticky, isHeader, newsType, text1, text2, id, data, data2, weekday, day, month, year = GetGuildNewsInfo(index);
			local isHeader, otext = Summary_RetrieveDB(idx, index, db);
			if (otext ) then
			else
				error("Did not return header or otext")
			end
			if ( isHeader ) then
				button.text:SetPoint("LEFT", 14, 0);
				button.text:SetText(otext);
				button.header:Show();
				button.icon:Hide();
				button.dash:Hide();
				button:Disable();
			else
				button.text:SetPoint("LEFT", 24, 0);
				button.icon:Hide();
				button.dash:Show();
				button.index = index;
				if (db ~= "achieves") then
					button.text:SetText(otext);
				else
					button.text:SetText("|cffffff00" .. otext .. "|r");
				end
				button.header:Hide();
				button:Enable();
			end
			button:Show();
		else
			--print("Button " .. index .. " hidden because was greater than " .. tostring((Summary_RetrieveDBLength(idx, db)-1)))
			button:Hide();
		end
	end
	if (db == "achieves") then
		_G["n_title"]:SetText("Achievements");
	elseif (db == "items") then
		_G["n_title"]:SetText("Items");
	elseif (db == "levels") then
		_G["n_title"]:SetText("Levels");
	end
	local buttonHeight = buttonss[1]:GetHeight();
	--print("DB length: " .. Summary_RetrieveDBLength(idx, db) .. " BH*DBL: " .. buttonHeight*Summary_RetrieveDBLength(idx, db) .. " NB*BH: " .. numButtons*scrollFrame.buttonHeight);
	HybridScrollFrame_Update(scrollFrame, buttonHeight*Summary_RetrieveDBLength(idx, db), numButtons*scrollFrame.buttonHeight)
	--HybridScrollFrame_Update(scrollFrame, buttonHeight*Summary_RetrieveDBLength(idx, db), buttonHeight*numButtons);
	--SummaryContainer.title:SetText(db);
end
------------------------------------------------------------------
--NECESSARY FRAME FUNCTIONS
local function n_addtab()
	if not n_tn then
		-- Create the button for the tab
		-- Do NOT change the frame name, it's magic, see FrameXML/UIPanelTemplates.lua
		oldNumTabs = CharacterFrame.numTabs
		n_tn = "CharacterFrameTab"..CharacterFrame.numTabs+1 
		local tab = CreateFrame( "Button", n_tn, CharacterFrame, "CharacterFrameTabButtonTemplate", CharacterFrame.numTabs+1 )
		tab:SetText("Logger")
		tab:SetPoint( "LEFT", "CharacterFrameTab"..CharacterFrame.numTabs, "RIGHT", -15, 0 )
		tab:SetScript( "OnEnter", function(self) 
			GameTooltip:SetOwner( self, "ANCHOR_RIGHT" )
			GameTooltip:SetText( "View log.", 1.0, 1.0, 1.0 )
		end )
		tab:SetScript( "OnLeave", GameTooltip_Hide )
		tab:SetScript( "OnClick", function(self)
			ToggleCharacter( "LoggerFrame" )
			N_mUpdate()
			n_createDrop()
			updateButtons(n_returnDailyIndex())
		end )
		
		-- Add our subframe to the list of frames
		tinsert( CHARACTERFRAME_SUBFRAMES, "LoggerFrame" )
		-- Increase the number of tabs to match
		PanelTemplates_SetNumTabs( CharacterFrame, CharacterFrame.numTabs+1 )
		-- Nudge the positioning/resizing so the game (hopefully) fits the tabs under the window again
		PanelTemplates_TabResize( _G[n_tn], 0 )
		CharacterFrame_TabBoundsCheck( _G[n_tn] )
	else
		_G[n_tn]:Show()
	end
end
------------------------------------------------------------------


--SETS THE DATE VARIABLE
function ReturnDate()
	ns.n_date = date("%m/%d/%y");
end;

--SETS THE TIME VARIABLE
function ReturnTime()
	n_time = date("%I:%M:%S \(%p\)");
end;

--ROUNDING FUNCTION
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end
-------------------


function stats_mean( t )
  local sum = 0
  local count= 0
  for k,v in pairs(t) do
    if type(v) == 'number' then
      sum = sum + v
      count = count + 1
    end
  end
  return (sum / count)
end

function n_killed(event, modlo)
	if (n_Settings.DBM.enabled) then
		local playerClass, englishClass = UnitClass("player");
		n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r killed " .. modlo.combatInfo.name .. " in " .. GetZoneText() .. ".");
	end
end

function n_wipe(event, modlo)
	if (n_Settings.DBM.enabled) then
		local playerClass, englishClass = UnitClass("player");
		n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r wiped on " .. modlo.combatInfo.name .. " in " .. GetZoneText() .. ".");
	end
end

function n_SettingsReset()
	n_Settings = ns.n_Settings_proper
end

function n_gnes()
	for i=1, GetNumGuildNews(), 1 do
		local isSticky, isHeader, newsType, text1, text2, id, data, data2, weekday, day, month, year = GetGuildNewsInfo(i);
		---- print("text1 == " .. text1 .. " text2 == " .. text2 .. " weekday == " .. weekday .. " day == " .. day .. " month == " .. month);
		if (newsType == 3 or newsType == 4 or newsType == 5) and (text1 == UnitName("player")) then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id);
			if (#n_log > 1 and n_log ~= nil) then
				for p,v in ipairs(n_log) do
					if (v["date"] == (month + 1) .. "/" .. (day + 1) .. "/" .. year) or (v["date"] == "0" .. (month + 1) .. "/" .. (day + 1) .. "/" .. year) or (v["date"] == (month + 1) .. "/0" .. (day + 1) .. "/" .. year) then
						if (v["items"] ~= nil) then
							local fi = nil;
							for x,y in ipairs(v["items"]) do
								if (itemLink == y["link"]) and (UnitName("player") == y["player"]) then
									fi = 1;
								end
							end
							if (fi ~= 1) then
								local tab = {}
								tab["link"] = itemLink;
								tab["player"] = UnitName("player");
								table.insert(v["items"], tab)
							end
						else
							v["items"] = {};
							local tab = {}
							tab["link"] = itemLink;
							tab["player"] = UnitName("player");
							table.insert(v["items"], tab)
						end
					end
				end
			else
				if (n_log[1]["date"] == (month + 1) .. "/" .. (day + 1) .. "/" .. year) or (n_log[1]["date"] == "0" .. (month + 1) .. "/" .. (day + 1) .. "/" .. year) or (n_log[1]["date"] == (month + 1) .. "/0" .. (day + 1) .. "/" .. year) then
					if (n_log[1]["items"] ~= nil) then
						local fi = nil;
						for x,y in ipairs(n_log[1]["items"]) do
							if (itemLink == y["link"]) and (UnitName("player") == y["player"]) then
								fi = 1;
							end
						end
						if (fi ~= 1) then
							local tab = {}
							tab["link"] = itemLink;
							tab["player"] = UnitName("player");
							table.insert(n_log[1]["items"], tab)
						end
					else
						n_log[1]["items"] = {};
						local tab = {}
						tab["link"] = itemLink;
						tab["player"] = UnitName("player");
						table.insert(n_log[1]["items"], tab)
					end
				end
			end
		end
	end
end
local DBMloaded = false;
function Logger_OnLoad(self)
	if (n_Settings == nil) then
		n_SettingsReset();
	end
	
	-- for j,k in pairs(n_Settings) do
		-- local discrepancy = false;
		-- for a, z in pairs(ns.n_Settings_proper) do
			-- if (j ~= a) then
				-- discrepancy = true;
				-- break
			-- end
		-- end
		-- if (discrepancy == true) then
			-- n_SettingsReset();
		-- end
	-- end
	if (n_Settings["version"] == nil) then
		n_SettingsReset();
		n_Settings["version"] = version;
	end
	if (n_Settings["version"] ~= nil) then
		if (n_Settings["version"] ~= version) then
			n_SettingsReset();
		end
	end
	ReturnDate();
	ReturnTime();
	for a, l in ipairs(ns.events) do
		self:RegisterEvent(l);
	end
	n_addtab();
	if (IsAddOnLoaded("DBM-Core")) then
		DBMloaded = true;
		DBM:RegisterCallback("kill", n_killed)
		DBM:RegisterCallback("wipe", n_wipe)
	end
	
	-----------------------------------------------------
	-------------INTERFACE DECLARATIONS------------------
	-----------------------------------------------------
	-------------------------MAIN FRAME------------------
	f = CreateFrame("Frame", "LoggerFrame", CharacterFrame)
	local n_wasCreated = 0;
	f:SetScript( "OnShow", function(self)
			CharacterFrame:SetWidth(CHARACTERFRAME_EXPANDED_WIDTH);
			--CharacterFrame:SetWidth(PANEL_DEFAULT_WIDTH);
			CharacterFrameInset:Hide();
			if n_wasCreated == 0 then
				n_createDrop();
				n_createOp();
				n_wasCreated = 1;
			end
			n_createDrop()
			--n_dropdown:Show();
	end )
	f:SetScript( "OnHide", function(self)
			N_mUpdate();
			CharacterFrame:SetWidth(PANEL_DEFAULT_WIDTH);
			CharacterFrameInset:Show();
			CloseDropDownMenus();
			--n_dropdown:Hide();
	end )
	f:SetFrameStrata("HIGH")
	f:SetPoint("TOPLEFT", "CharacterFrameInset", 0, -4);
	f:SetPoint("BOTTOMRIGHT", "CharacterFrame", -25, 6);
	-----------------------------------------------------
	------------ART FRAME------------------------------
	n_art = CreateFrame("Frame", "LoggerArtFrame", CharacterFrame, "InsetFrameTemplate");
	n_art:SetAllPoints(f);
	n_art:SetPoint("BOTTOMRIGHT", "CharacterFrame", -4, 4);
	-----------------------------------------------------
	--------------------TIME FRAME-----------------------
	g = CreateFrame("Frame", "LoggerTime", f)
	g:SetScript( "OnShow", function(self)
			maxScroll = n_scroll:GetVerticalScrollRange();
			n_scroll:SetVerticalScroll(maxScroll);
	end )
	local n_run = 0;
	g:SetScript( "OnUpdate", function(self)
			if g:IsVisible() then
				self:SetWidth(n_tim:GetStringWidth() + 30);
				if (shownDateIndex ~= 0) then
					if (shownDateIndex == n_returnDailyIndex()) then
						n_fin = time();
						n_sub = (n_fin - n_org) + n_log[n_returnDailyIndex()]["tt"];
						n_sub = SecondsToClock(n_sub);
						n_tim:SetText("Time today: |cFFFFFFFF" .. n_sub .. "|r");
					-- elseif (shownDateIndex == 0) then
						-- n_fin = time();
						-- n_sub = (n_fin - n_org) + n_log[n_returnDailyIndex()]["tt"];
						-- n_sub = SecondsToClock(n_sub);
						-- n_tim:SetText("Time today: |cFFFFFFFF" .. n_sub .. "|r");
					else
						n_sub = SecondsToClock(n_log[shownDateIndex]["tt"]);
						n_tim:SetText("Time this day: |cFFFFFFFF" .. n_sub .. "|r");
					end
				end
			end
	end )
	hooksecurefunc("ToggleGuildFrame", function(...)
		n_gnes();
	end)
	-- hooksecurefunc("WorldStateScoreFrame_Update", function(...)
		-- local battlefieldWinner = GetBattlefieldWinner();
		-- if (battlefieldWinner) then
			-- for i = 1, GetNumBattlefieldScores() do
				-- if (name == UnitName("player")) then
					-- local playerClass, englishClass = UnitClass("player");
					-- local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange, preMatchMMR, mmrChange, talentSpec = GetBattlefieldScore(i);
					-- local fcolors = ""
					-- if (faction == 1) then
						-- fcolors = "|cFF00FFFF"
					-- else
						-- fcolors = "|cFF8B0000"
					-- end
					-- n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r finished " .. fcolors .. GetZoneText() .. "|r with " .. tostring(killingBlows) .. " killing blows, " .. tostring(honorableKills) .. " HKs, and " .. tostring(deaths) .. " deaths. Gained " .. tostring(honorGained) .. " honor. (|cFFDC143C" .. valShort(damageDone) .. "|rDD/|cFF7FFF00" .. valShort(healingDone) .. "|rHD)");
				-- end
			-- end
		-- end
	-- end)
	g:SetFrameStrata("HIGH")
	g:SetPoint("TOPLEFT", "CharacterFrame", 35, -30);
	g:SetWidth(150)
	g:SetHeight(32)
	g:SetScript( "OnEnter", function(self) 
		local t = {};
		local tot = 0;
		if (#n_log > 1 and n_log ~= nil) then
			for p,v in ipairs(n_log) do
				table.insert(t,tonumber(v["tt"]));
				tot = tonumber(v["tt"]) + tot;
			end
		else
			table.insert(t,tonumber(n_log[1]["tt"]));
			tot = tonumber(n_log[1]["tt"]) + tot;
		end
		local mean = stats_mean(t);
		mean = SecondsToClock(mean);
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:SetText( "|cFF827351Average time per day:|r " .. mean .. "\n|cFF827351Time since install:|r " .. SecondsToClock(tot), 1.0, 1.0, 1.0 )
	end )
	g:SetScript( "OnLeave", GameTooltip_Hide )
	-----------------DATE BUTTON------------------------
	asda = CreateFrame("Button", "LoggerHistoryButton", f);
	asda:SetPoint("TOPRIGHT", "CharacterFrame", "TOPRIGHT", -2, -30);
	asda:SetNormalFontObject("GameFontNormal")
	asda:RegisterForClicks("AnyUp")
	asda:SetWidth(100);
	asda:SetHeight(32);
	asda:SetScript( "OnClick", function(self, button, down)
		if (button == "LeftButton") then
			ToggleDropDownMenu(1, nil, n_dropdown, self:GetName(), 0, 0)
		elseif (button == "MiddleButton") then
			N_mUpdate()
		elseif (button == "RightButton") then
			ToggleDropDownMenu(1, nil, n_OptionsDropDownMenu, self:GetName(), 0, 0)
		end
	end );
	asda:SetScript( "OnEnter", function(self) 
			GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
			GameTooltip:SetText( "|cFFFFFFFFLeft-click|r to view logs of other dates.\n|cFFFFFFFFMiddle-click|r to load today's log.\n|cFFFFFFFFRight-click|r to open logging options.")
		end )
	asda:SetScript("OnUpdate", function(self)

		asda:SetWidth(self:GetTextWidth() + 30);
	end )
	asda:SetScript( "OnLeave", GameTooltip_Hide )
	-- n_txt2 = g:CreateTexture(nil, "ARTWORK");
	-- n_txt2:SetBlendMode("ADD");
	-- n_txt2:SetTexture("Interface\\Glues\\CharacterSelect\\Glue-CharacterSelect-Hover.blp");
	-- n_txt2:SetAllPoints(asda)
	-- g.texture = n_txt
	-- asda:SetScript( "OnEnter", function() 
		-- GameTooltip:SetOwner( self, "ANCHOR_RIGHT" )
		-- GameTooltip:SetText("Left|cFFB048F8-click to view logs of other dates.|r\nRight|cFFB048F8-click to load today.|r")
	-- end )
	-- asda:SetScript( "OnLeave", GameTooltip_Hide )
	------------------------TITLE-----------------------
	-- font = f:CreateFontString("LoggerTitle", "HIGH", "QuestFont_Super_Huge");
	-- font:SetText("LoggerPro");
	-- font:SetPoint("TOPLEFT", "CharacterFrame", 60, -30);
	----------------------------------------------------
	-----------------------TIMETITLE--------------------
	n_tim = g:CreateFontString("LoggerTitle", "HIGH", "GameFontNormal");
	n_tim:SetText("Test");
	n_tim:SetPoint("CENTER", "LoggerTime");
	----------------------------------------------------
	-------------------------ScrollFrame----------------
	n_scroll = CreateFrame("ScrollFrame", "LoggerScroll", f, "UIPanelScrollFrameTemplate2")
	n_scroll:SetAllPoints(f);
	n_scroll:SetPoint("TOPLEFT", "CharacterFrameInset", 4, -12);
	----------------------------------------------------
	---Summary frame
	n_summary = CreateFrame("Frame", "LoggerSummary", LoggerFrame);
	n_summary:SetAllPoints(f);
	n_summary:SetPoint("BOTTOMRIGHT", "LoggerFrame", "BOTTOMRIGHT", 16, 0);
	local n_txtz = n_summary:CreateTexture(nil, "ARTWORK");
	n_txtz:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-BACKGROUND");
	n_txtz:SetAllPoints(n_summary)
	n_summary.texture = n_txtz
	n_summary:Hide();
	local buttons = { "Levels", "Items", "Achievements"}
	local buttons = { "Levels", "Items", "Achievements"}
	for i = 1, #buttons do
		ns.sum_buttons[i] = CreateFrame("Button", "LoggerTestButton" .. i, n_summary, "LoggerButtonTemplate");
		ns.sum_buttons[i]:SetWidth(200);
		ns.sum_buttons[i]:RegisterForClicks("LeftButtonUp");
		--_G["LoggerTestButton" .. i .. "Label"]:SetTextColor(1/255,32/255,6/255,1);
		_G["LoggerTestButton" .. i .. "Label"]:SetText(buttons[i]);
		ns.sum_buttons[i]:SetScript( "OnClick", function(self, button, down)
			Summary_Update(_G[self:GetName() .. "Label"]:GetText())
		end );
		ns.sum_buttons[i].oText = function(text)
			_G[self:GetName() .. "Label"]:SetText(text);
		end
		ns.sum_buttons[i]:SetHeight(50);
		if (i == 1) then
			ns.sum_buttons[i]:SetPoint("TOPLEFT", "LoggerSummary", "TOPLEFT", 0,0);
		else
			ns.sum_buttons[i]:SetPoint("TOPLEFT", "LoggerTestButton" .. tostring(i-1), "BOTTOMLEFT", 0,0);
		end
	end
	n_txtz:SetPoint("TOPLEFT", "LoggerTestButton1", "TOPRIGHT", 0, 0);
	n_summary_log = CreateFrame("Frame", "LoggerSummaryLog", n_summary, "LoggerSummaryTemplate");
	n_summary_log:SetAllPoints(n_txtz);
	--_G["SummaryContainer"].scrollBar:Hide();
	_G["SummaryContainer"]:SetScript("OnMouseWheel", function(self, delta, stepSize)
		-- if ( not self.scrollBar:IsVisible() ) then
			-- return;
		-- end
		local numbutts = #self.buttons;
		local minVal, maxVal = numbutts*self.buttonHeight, self.range;
		stepSize = stepSize or self.stepSize or self.buttonHeight;
		if ( delta == 1 ) then
			self.scrollBar:SetValue(max(0, self.scrollBar:GetValue() - stepSize));
		else
			if (maxVal ~= nil) then
				self.scrollBar:SetValue(min(maxVal, self.scrollBar:GetValue() + stepSize));
			else
				self.scrollBar:SetValue(min(numbutts*self.buttonHeight, self.scrollBar:GetValue() + stepSize));
			end
		end
		Summary_Update();
	end )
	_G["SummaryContainerScrollBarScrollDownButton"]:SetScript("OnClick", function(self, button, down)
		local numbutts = #_G["SummaryContainer"].buttons;
		local minVal, maxVal = numbutts*_G["SummaryContainer"].buttonHeight, _G["SummaryContainer"].range;
		stepSize = stepSize or _G["SummaryContainer"].stepSize or _G["SummaryContainer"].buttonHeight;
		_G["SummaryContainerScrollBar"]:SetValue(min(360, _G["SummaryContainerScrollBar"]:GetValue() + stepSize));
		Summary_Update();
	end )
	_G["SummaryContainerScrollBarScrollUpButton"]:SetScript("OnClick", function(self, button, down)
		local numbutts = #_G["SummaryContainer"].buttons;
		local minVal, maxVal = numbutts*_G["SummaryContainer"].buttonHeight, _G["SummaryContainer"].range;
		stepSize = stepSize or _G["SummaryContainer"].stepSize or _G["SummaryContainer"].buttonHeight;
		_G["SummaryContainerScrollBar"]:SetValue(min(0, _G["SummaryContainerScrollBar"]:GetValue() - stepSize));
		Summary_Update();
	end )
	----------------------------------------------------
	-----------------------LOGFIELD---------------------
	textArea = CreateFrame("EditBox", "LoggerScrollText", n_scroll)
	textArea:SetTextColor(1, 1, 1, 1);
	textArea:SetAllPoints(n_scroll);
	textArea:SetAutoFocus(false)
	textArea:SetMultiLine(true)
	textArea:SetFontObject("GameFontNormal")
	textArea:EnableMouse(true)
	textArea:Disable();
	textArea:SetHyperlinksEnabled(true);
	textArea:SetScript( "OnHyperLinkEnter", function(self, linkData, link)
		GameTooltip:Hide()
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(link);
		GameTooltip:Show()
	end );
	textArea:SetScript( "OnHyperLinkLeave", function(self, linkData, link)
		GameTooltip:Hide()
	end );
	textArea:SetScript("OnEscapePressed", textArea.ClearFocus);
	textArea:SetWidth(500);
	----------------------------------------------------
	local tab2 = CreateFrame("Button", "LoggerLogTab2", f, "LoggerPaperDollSidebarTabTemplate");
	tab2:SetPoint("BOTTOMRIGHT", asda, "BOTTOMLEFT", 0,-5);
	tab2:RegisterForClicks("LeftButtonUp")
	tab2:SetScript( "OnShow", function(self)
		--self.Icon:SetTexture(PAPERDOLL_SIDEBARS[3].icon);
		self.Icon:SetTexture("Interface\\Icons\\INV_Scroll_03");
		-- local tcoords = PAPERDOLL_SIDEBARS[3].texCoords;
		-- self.Icon:SetTexCoord(tcoords[1], tcoords[2], tcoords[3], tcoords[4]);
	end );
	tab2:SetScript( "OnEnter", function(self, linkData, link)
		GameTooltip:Hide()
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:SetText("Summary");
		GameTooltip:Show()
	end );
	tab2:SetScript( "OnLeave", function(self, linkData, link)
		GameTooltip:Hide()
	end );
	---Log tab
	local tab1 = CreateFrame("Button", "LoggerLogTab1", f, "LoggerPaperDollSidebarTabTemplate")
	tab1:RegisterForClicks("LeftButtonUp")
	tab1:SetScript( "OnShow", function(self)
		self.Icon:SetTexture(PAPERDOLL_SIDEBARS[2].icon);
		local tcoords = PAPERDOLL_SIDEBARS[2].texCoords;
		self.Icon:SetTexCoord(tcoords[1], tcoords[2], tcoords[3], tcoords[4]);
	end );
	tab1:SetScript( "OnEnter", function(self, linkData, link)
		GameTooltip:Hide()
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:SetText("Log");
		GameTooltip:Show()
	end );
	tab1:SetScript( "OnLeave", function(self, linkData, link)
		GameTooltip:Hide()
	end );
	tab1:SetPoint("BOTTOMRIGHT", tab2, "BOTTOMLEFT", -3,0);
	---TAB LOADS
	tab2:SetScript( "OnClick", function(self, button, down)
		n_createDrop()
		n_scroll:Hide();
		tab2.Highlight:Show();
		tab1.Highlight:Hide();
		n_summary:Show();
	end );
	tab1:SetScript( "OnClick", function(self, button, down)
		n_scroll:Show();
		tab1.Highlight:Show();
		tab2.Highlight:Hide();
		n_summary:Hide();
	end );
	---------------HISTORY BUTTON------------------------
	local wid_th = CHARACTERFRAME_EXPANDED_WIDTH - 5;
	n_scroll:SetScrollChild(textArea)
	f:Hide()
end;

function get_day_of_week(dd, mm, yy) 
	
  local days = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" }

  local mmx = mm

  if (mm == 1) then  mmx = 13; yy = yy-1  end
  if (mm == 2) then  mmx = 14; yy = yy-1  end

  local val8 = dd + (mmx*2) +  math.floor(((mmx+1)*3)/5)   + yy + math.floor(yy/4)  - math.floor(yy/100)  + math.floor(yy/400) + 2
  local val9 = math.floor(val8/7)
  local dw = val8-(val9*7) 

  if (dw == 0) then
    dw = 7
  end

  return days[dw]
end

function n_createDrop()
	n_returnDailyIndex()
	bubbleSort(n_log);
	-- n_dropdown = CreateFrame("Frame", "LoggerDropDown", LoggerFrame, "UIDropDownMenuTemplate")
	n_dropdown = CreateFrame("Frame", "LoggerDropDown", LoggerFrame)
	n_dropdown.displayMode = "MENU";
	n_dropdown.info = {}
	local mts = {}
		if ((#n_log >1) and (n_log ~= nil)) then
			for p,v in ipairs(n_log) do
				local fnd = 0;
				for x,y in ipairs (mts) do
					if (y["month"] == tonumber(string.sub(v["date"],1,2)) and y["year"] == tonumber(string.sub(v["date"],7,8))) then
						table.insert(y, v["date"]);
						fnd = 1;
					end
				end
				if (fnd == 0) then
					local dtbl = {}
					dtbl["month"] = tonumber(string.sub(v["date"],1,2));
					dtbl["year"] = tonumber(string.sub(v["date"],7,8));
					table.insert(dtbl, v["date"])
					table.insert(mts, dtbl)
				end
			end
		else
			local fnd = 0;
			for x,y in ipairs (mts) do
				if (y["month"] == tonumber(string.sub(n_log[1]["date"],1,2)) and y["year"] == tonumber(string.sub(n_log[1]["date"],7,8))) then
					table.insert(y, n_log[1]["date"]);
					fnd = 1;
				end
			end
			if (fnd == 0) then
				local dtbl = {}
				dtbl["month"] = tonumber(string.sub(n_log[1]["date"],1,2));
				dtbl["year"] = tonumber(string.sub(n_log[1]["date"],7,8));
				table.insert(dtbl, n_log[1]["date"])
				table.insert(mts, dtbl)
			end
		end
	UIDropDownMenu_Initialize(n_dropdown, function(self, level, menuList)
		if (level == 1) then
			local info = UIDropDownMenu_CreateInfo();
			info.isTitle = 1
			info.text = "Logged Dates"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info)
			for p,v in ipairs(mts) do
				local tm = 0;
				local ac = 0;
				local lc = 0;
				local ic = 0;
				local acnt = 0;
				local achi = {}
				local cn = ""
				local lcnt = 0;
				local ltab = {}
				local itbl = {}
				for j,k in ipairs(v) do
					local idx = nil;
					for a,s in ipairs(n_log) do
						if (s["date"] == k) then
							idx = a;
						end
					end
					tm = tm + n_log[idx]["tt"];
					if (n_log[idx]["items"] ~= nil) then
						ic = ic + #n_log[idx]["items"]
					end
					if (n_log[idx]["items"] ~= nil) then
								for y,u in ipairs(n_log[idx]["items"]) do
									cn = "";
									if (#n_log > 1 and n_log ~= nil) then
										for you, me in ipairs(n_log) do
											if (cn ~= "") then
												break
											end
											for he, she in ipairs(n_log[you]) do
												local startPos, endPos, firstWord, restOfString = string.find( n_log[you][he], "|c.+" .. u["player"] .. "|r");
												if (startPos ~= nil and endPos ~= nil) then
													cn = string.sub(n_log[you][he], startPos, endPos)
													break
												end
											end
										end
									else
										for he, she in ipairs(n_log[1]) do
											local startPos, endPos, firstWord, restOfString = string.find( n_log[1][he], "|c.+" .. u["player"] .. "|r");
											if (startPos ~= nil and endPos ~= nil) then
												cn = string.sub(n_log[1][he], startPos, endPos)
												break
											end
										end
									end
									if (itbl[cn] == nil) then
										itbl[cn] = {}
										table.insert(itbl[cn], u["link"])
									else
										local found = false;
										for fuck,you in ipairs(itbl) do
											if (you == u["link"]) then
												found = true;
												break
											end
										end
										if (found == false) then
											table.insert(itbl[cn], u["link"])
										end
								end
							end
					end
					for i,l in ipairs(n_log[idx]) do
						if (string.find(n_log[idx][i], "earned the achievement") ~= nil) then
							local startPos, endPos, firstWord, restOfString = string.find( n_log[idx][i], "%)%s|c.+%a+%sea");
							if (startPos ~= nil and endPos ~= nil) then
								cn = string.sub(n_log[idx][i], startPos+2, endPos-3)
								local alink = string.match(n_log[idx][i], "|Hachievement.+|h|r")
								if (achi[cn] == nil) then
									achi[cn] = {}
									table.insert(achi[cn], alink);
								else 
									table.insert(achi[cn], alink);
								end
							end
							ac = ac + 1;
						end
						if (string.find(n_log[idx][i], "leveled up") ~= nil) then
							local startPos, endPos, firstWord, restOfString = string.find( n_log[idx][i], "%)%s|c.+%a+%sle");
							if (startPos ~= nil and endPos ~= nil) then
								cn = string.sub(n_log[idx][i], startPos+2, endPos-3)
								local slev = nil;
								for jack,jill in ipairs(n_log[idx]) do
									-- ;
									-- if (s ~= nil and e ~= nil) then
										-- slev = tonumber(string.sub(jill,s+string.len(cn)+9,e-1));
										-- break
									-- end
									if (string.find( jill, cn) ~= nil) then
										local s, e, fw, ro = string.find( jill,"%slevel%s%d+%s")
										if (s ~= nil and e ~= nil) then
											slev = tonumber(string.sub(jill,s+7,e-1));
											break
										end
									end
								end
								local s, e, fw, ro = string.find( n_log[idx][i], cn .. "%sleveled%sup%sto%s%d+%.");
								local lev = tonumber(string.sub(n_log[idx][i],s+string.len(cn)+15,e-1));
								if (ltab[cn] == nil) then
									ltab[cn] = {}
									ltab[cn]["slevel"] = slev;
									table.insert(ltab[cn], lev);
								else 
									local found = false;
									for fuck,you in ipairs(ltab) do
										if (you == lev) then
											found = true;
											break
										end
									end
									if (found == false) then
										table.insert(ltab[cn], lev);
									end
								end
							end
							lc = lc + 1;
						end
					end
				end
				wipe(info)
				info = UIDropDownMenu_CreateInfo();
				info.text = tostring(ns.months[v["month"]]) .. " 20" .. tostring(v["year"]);
				info.text = info.text .. " |cFF827351(" .. SecondsToClock(tm) .. ")|r"
				if (ac ~= 0) then
					info.text = info.text .. " |cffffff00(" .. ac .. ")|r";
				end
				if (lc ~= 0) then
					info.text = info.text .. " |cFFC9B518(" .. lc .. ")|r";
				end
				if (ic ~= 0) then
					info.text = info.text .. " |cFFB048F8(" .. ic .. ")|r"
				end
				info.hasArrow = 1;
				info.menuList = tostring(ns.months[v["month"]]) .. " 20" .. tostring(v["year"]);
				info.value = tostring(ns.months[v["month"]]) .. " 20" .. tostring(v["year"]);
				info.notCheckable = 1;
				info.tooltipTitle = tostring(ns.months[v["month"]])
				info.tooltipText = "|cFFD1D1D120" .. tostring(v["year"]) .. "|r"
				if (ac ~= 0 or lc ~= 0 or ic ~= 0) then
					if (ic ~= 0) then
						info.tooltipText = info.tooltipText .. "\n|TInterface\\Icons\\INV_Shoulder_Leather_RaidRogue_K_01:12|t|cFFB048F8Items (" .. ic .. "):|r|TInterface\\Icons\\INV_Shoulder_Leather_RaidRogue_K_01:12|t"
						for y,u in pairs(itbl) do
							info.tooltipText = info.tooltipText .. "\n" .. y .. ":"
							if (#u < 5) then
								for j,k in ipairs(u) do
									info.tooltipText = info.tooltipText .. "\n     " .. k
								end
							else
								local lkk = 0;
								for j,k in ipairs(u) do
									if (lkk <= 5) then
										info.tooltipText = info.tooltipText .. "\n     " .. k
										lkk = lkk + 1;
									else
										local len = #u-5
										info.tooltipText = info.tooltipText .. "\n     |cFFFFB917And " .. len .. " other items.|r "
										break
									end
								end
							end
						end
					end
					if (lc ~= 0) then
						info.tooltipText = info.tooltipText .. "\n|TInterface\\Icons\\Ability_Paladin_TouchedbyLight:12|t|cFFC9B518Levels (" .. lc .. "):|r|TInterface\\Icons\\Ability_Paladin_TouchedbyLight:12|t"
						for y,u in pairs(ltab) do
							local sl = u["slevel"]
							local el = u["slevel"]
							-- print( " .. tostring(sl) .. " el: " .. tostring(el));
							for hate,love in ipairs(u) do
								--print("Hate: " .. tostring(hate) .. " Love: " .. tostring(love));
								if (love > el) then
									el = love;
								end
							end
							info.tooltipText = info.tooltipText .. "\n     " .. y .. ": |cFFC9B518" .. sl .. "-" .. el .. "|r"
						end
					end
					if (ac ~= 0) then
						info.tooltipText = info.tooltipText .. "\n|TInterface\\Icons\\Achievement_Arena_2v2_6:12|t|cFFFFB917Achievements (" .. ac .. "):|r|TInterface\\Icons\\Achievement_Arena_2v2_6:12|t"
						for y,u in pairs(achi) do
							info.tooltipText = info.tooltipText .. "\n" .. y .. ":"
							if (#u < 5) then
								for j,k in ipairs(u) do
									info.tooltipText = info.tooltipText .. "\n     " .. k
								end
							else
								local lkk = 0;
								for j,k in ipairs(u) do
									if (lkk <= 5) then
										info.tooltipText = info.tooltipText .. "\n     " .. k
										lkk = lkk + 1;
									else
										local len = #u-5
										info.tooltipText = info.tooltipText .. "\n     |cFFFFB917And " .. len .. " other achievements.|r "
										break
									end
								end
							end
						end
					end
				end
				UIDropDownMenu_AddButton(info, level);
			end
		elseif (level == 2) then
			local info = UIDropDownMenu_CreateInfo();
			for x,s in ipairs(mts) do
				if (tostring(ns.months[s["month"]]) .. " 20" .. tostring(s["year"]) == UIDROPDOWNMENU_MENU_VALUE) then 
					for a,z in ipairs(s) do
						local compi = {}
						local info = UIDropDownMenu_CreateInfo();
						local idx = nil;
						if (#n_log > 1 and n_log ~= nil) then
							for l,k in ipairs(n_log) do
								if (k["date"] == z) then
									idx = l;
								end
							end
						else
							if (n_log[1]["date"] == z) then
								idx = 1;
							end
						end
						local apd = "";
						if (tonumber(string.sub(n_log[idx]["date"],4,5)) == 1 or tonumber(string.sub(n_log[idx]["date"],4,5)) == 21 or tonumber(string.sub(n_log[idx]["date"],4,5)) == 31) then
							apd = "st"
						elseif (tonumber(string.sub(n_log[idx]["date"],4,5)) == 2 or tonumber(string.sub(n_log[idx]["date"],4,5)) == 22) then
							apd = "nd"
						elseif (tonumber(string.sub(n_log[idx]["date"],4,5)) == 3 or tonumber(string.sub(n_log[idx]["date"],4,5)) == 23) then
							apd = "rd"
						elseif ((tonumber(string.sub(n_log[idx]["date"],4,5)) >= 4 and tonumber(string.sub(n_log[idx]["date"],4,5)) <= 20) or (tonumber(string.sub(n_log[idx]["date"],4,5)) >= 24 and tonumber(string.sub(n_log[idx]["date"],4,5)) <= 30)) then
							apd = "th"
						end
						z = get_day_of_week(tonumber(string.sub(n_log[idx]["date"],4,5)),tonumber(string.sub(n_log[idx]["date"],1,2)),tonumber(string.sub(n_log[idx]["date"],7,8))) .. ", " .. tostring(ns.months[s["month"]]) .. " " .. tostring(tonumber(string.sub(n_log[idx]["date"],4,5))) .. apd
						info.text = z
						if (idx == n_returnDailyIndex()) then
							info.text = "|cFFFFD700" .. z .. "|r"
						end
						info.text = info.text .. " |cFF827351(" .. SecondsToClock(n_log[idx]["tt"]) .. ")|r"
						-- Counts achievements
						local acnt = 0;
						local achi = {}
						local cn = ""
						for i,l in ipairs(n_log[idx]) do
							if (string.find(n_log[idx][i], "earned the achievement") ~= nil) then
								local startPos, endPos, firstWord, restOfString = string.find( n_log[idx][i], "%)%s|c.+%a+%sea");
								if (startPos ~= nil and endPos ~= nil) then
									cn = string.sub(n_log[idx][i], startPos+2, endPos-3)
									local alink = string.match(n_log[idx][i], "|Hachievement.+|h|r")
									if (achi[cn] == nil) then
										achi[cn] = {}
										table.insert(achi[cn], alink);
									else
										table.insert(achi[cn], alink);
									end
								end
								acnt = acnt + 1;
							end
						end
						if (acnt ~= 0) then
							info.text = info.text .. " |cffffff00(" .. acnt .. ")|r";
							
						end
						-- Counts levelups
						local lcnt = 0;
						local ltab = {}
						for i,l in ipairs(n_log[idx]) do
							local cn = ""
							if (string.find(n_log[idx][i], "leveled up") ~= nil) then
								local startPos, endPos, firstWord, restOfString = string.find( n_log[idx][i], "%)%s|c.+%a+%sle");
								if (startPos ~= nil and endPos ~= nil) then
									cn = string.sub(n_log[idx][i], startPos+2, endPos-3)
									local slev = nil;
									for jack,jill in ipairs(n_log[idx]) do
										
										if (string.find( jill, cn) ~= nil) then
											local s, e, fw, ro = string.find( jill,"%slevel%s%d+%s")
											if (s ~= nil and e ~= nil) then
												slev = tonumber(string.sub(jill,s+7,e-1));
												break
											end
										end
									end
									local s, e, fw, ro = string.find( n_log[idx][i], cn .. "%sleveled%sup%sto%s%d+%.");
									local lev = tonumber(string.sub(n_log[idx][i],s+string.len(cn)+15,e-1));
									if (ltab[cn] == nil) then
										ltab[cn] = {}
										ltab[cn]["slevel"] = slev;
										table.insert(ltab[cn], lev);
									else 
										local found = false;
										for fuck,you in ipairs(ltab) do
											if (you == lev) then
												found = true;
												break
											end
										end
										if (found == false) then
											table.insert(ltab[cn], lev);
										end
									end
								end
								lcnt = lcnt + 1;
							end
						end
						if (lcnt ~= 0) then
							info.text = info.text .. " |cFFC9B518(" .. lcnt .. ")|r";
							
						end
						--------------
						if (n_log[idx]["items"] ~= nil) then
							info.text = info.text .. " |cFFB048F8(" .. tostring(#n_log[idx]["items"]) .. ")|r"
							local itemtemp = {}
							for kl, lk in ipairs(n_log[idx]["items"]) do
								if (itemtemp[lk["player"]] == nil) then
									itemtemp[lk["player"]] = {}
								end
								table.insert(itemtemp[lk["player"]], lk["link"]);
							end
							
						end
						
						info.tooltipTitle = tostring(ns.months[s["month"]]) .. " " .. tostring(tonumber(string.sub(n_log[idx]["date"],4,5))) .. apd .. ", 20" .. tostring(string.sub(n_log[idx]["date"],7,8))
						info.tooltipText = "|cFFD1D1D1" .. get_day_of_week(tonumber(string.sub(n_log[idx]["date"],4,5)),tonumber(string.sub(n_log[idx]["date"],1,2)),tonumber(string.sub(n_log[idx]["date"],7,8))) .. "|r"
						if (acnt ~= 0 or lcnt ~= 0 or n_log[idx]["items"] ~= nil) then
							if (n_log[idx]["items"] ~= nil) then
								local itbl = {}
								--info.tooltipText = info.tooltipText .. "\n|cFFB048F8Obtained " .. tostring(#n_log[idx]["items"]) .. " epic or better items."
								info.tooltipText = info.tooltipText .. "\n|TInterface\\Icons\\INV_Shoulder_Leather_RaidRogue_K_01:12|t|cFFB048F8Items (" .. tostring(#n_log[idx]["items"]) .. "):|r|TInterface\\Icons\\INV_Shoulder_Leather_RaidRogue_K_01:12|t"
								for y,u in ipairs(n_log[idx]["items"]) do
									local cn = "";
									if (#n_log > 1 and n_log ~= nil) then
										for you, me in ipairs(n_log) do
											if (cn ~= "") then
												break
											end
											for he, she in ipairs(n_log[you]) do
												local startPos, endPos, firstWord, restOfString = string.find( n_log[you][he], "|c.+" .. u["player"] .. "|r");
												if (startPos ~= nil and endPos ~= nil) then
													cn = string.sub(n_log[you][he], startPos, endPos)
													break
												end
											end
										end
									else
										for he, she in ipairs(n_log[1]) do
											local startPos, endPos, firstWord, restOfString = string.find( n_log[1][he], "|c.+" .. u["player"] .. "|r");
											if (startPos ~= nil and endPos ~= nil) then
												cn = string.sub(n_log[1][he], startPos, endPos)
												break
											end
										end
									end
									if (itbl[cn] == nil) then
										itbl[cn] = {}
										table.insert(itbl[cn], u["link"])
									else 
										table.insert(itbl[cn], u["link"])
									end
								end
								for y,u in pairs(itbl) do
									info.tooltipText = info.tooltipText .. "\n" .. y .. ":"
									if (#u < 5) then
										for j,k in ipairs(u) do
											info.tooltipText = info.tooltipText .. "\n     " .. k
										end
									else
										local lkk = 0;
										for j,k in ipairs(u) do
											if (lkk <= 5) then
												info.tooltipText = info.tooltipText .. "\n     " .. k
												lkk = lkk + 1;
											else
												local len = #u-5
												info.tooltipText = info.tooltipText .. "\n     |cFFFFB917And " .. len .. " other items.|r "
												break
											end
										end
									end
								end
								compi["items"] = itbl;
								compi["items"]["count"] = #n_log[idx]["items"];
							end
							if (lcnt ~= 0) then
								local levelarray = {}
								-- if (lcnt == 1) then
									-- info.tooltipText = info.tooltipText .. "\n|cFFC9B518Gained " .. lcnt .. " level."
								-- else
									-- info.tooltipText = info.tooltipText .. "\n|cFFC9B518Gained " .. lcnt .. " levels."
								-- end
								info.tooltipText = info.tooltipText .. "\n|TInterface\\Icons\\Ability_Paladin_TouchedbyLight:12|t|cFFC9B518Levels (" .. lcnt .. "):|r|TInterface\\Icons\\Ability_Paladin_TouchedbyLight:12|t"
								for y,u in pairs(ltab) do
									local sl = u["slevel"]
									local el = u["slevel"]
									for hate,love in ipairs(u) do
										if (love > el) then
											el = love;
										end
									end
									info.tooltipText = info.tooltipText .. "\n" .. y .. ": |cFFC9B518" .. sl .. "-" .. el .. "|r"
									if (levelarray[y] == nil) then
										levelarray[y] = {}
									end
									levelarray[y] = sl .. "-" .. el;
								end
								compi["levels"] = levelarray;
								compi["levels"]["count"] = lcnt;
							end
							if (acnt ~= 0) then
								info.tooltipText = info.tooltipText .. "\n|TInterface\\Icons\\Achievement_Arena_2v2_6:12|t|cFFFFB917Achievements (" .. acnt .. "):|r|TInterface\\Icons\\Achievement_Arena_2v2_6:12|t"
								for y,u in pairs(achi) do
									info.tooltipText = info.tooltipText .. "\n" .. y .. ":"
									if (type(u) ~= "number") then
										if (#u < 5) then
											for j,k in ipairs(u) do
												info.tooltipText = info.tooltipText .. "\n     " .. k
											end
										else
											local lkk = 0;
											for j,k in ipairs(u) do
												if (lkk <= 5) then
													info.tooltipText = info.tooltipText .. "\n     " .. k
													lkk = lkk + 1;
												else
													local len = #u-5
													info.tooltipText = info.tooltipText .. "\n     |cFFFFB917And " .. len .. " other achievements.|r "
													break
												end
											end
										end
									end
									compi["achieves"] = achi;
									compi["achieves"]["count"] = acnt;
								end
								--info.tooltipText = info.tooltipText .. "\n|cFFFFB917Achieved " .. acnt .. " achievements."
							end
						end
						info.tooltipText = nil;
						info.value = tonumber(z)
						info.notCheckable = 1;
						info.func = function(self)
							if (z ~= ns.n_date) then
								N_sUpdate(n_log[idx]["date"]);
							else
								N_mUpdate();
							end
							CloseDropDownMenus()
						end;
						UIDropDownMenu_AddButton(info, level)
						n_log[idx]["summary"] = compi;
					end
				end
			end
			-- if UIDROPDOWNMENU_MENU_VALUE == "June" then
			    -- info.text = "Foo"
			    -- UIDropDownMenu_AddButton(info, level)

			    -- info.text = "Bar"
			    -- UIDropDownMenu_AddButton(info, level)
			 -- end
		end
	end)
	n_dropdown:SetFrameLevel(999);
	n_dropdown:SetFrameStrata("HIGH");
	n_dropdown:SetPoint("TOPRIGHT", "CharacterFrame", -20, -30);
	-- UIDropDownMenu_SetSelectedID(LoggerDropDown, n_returnDailyIndex());
	f:SetScript( "OnUpdate", function(self)
			n_scroll:SetPoint("BOTTOMRIGHT", "CharacterFrame", -31, 6);
			if (f:IsVisible() == 1) then
				n_dropdown:Show();
			else 
				n_dropdown:Hide();
			end
	end );
	-- UIDropDownMenu_SetSelectedID(LoggerDropDown, n_returnDailyIndex());
end

function n_createOp()
	n_OptionsDropDownMenu = CreateFrame("Frame", "LoggerOptionsDropDown")
	n_OptionsDropDownMenu.displayMode = "MENU"
	UIDropDownMenu_Initialize(n_OptionsDropDownMenu, function(self, level, menuList)	
		if (level == 1) then
			local info = UIDropDownMenu_CreateInfo();
			info.isTitle = 1
			info.text = "Logging Options"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info)
			for p,v in pairs(n_Settings) do
				if (p ~= "version") then
					wipe(info)
					info = UIDropDownMenu_CreateInfo();
					info.disabled     = nil
					info.isTitle      = nil
					info.notCheckable = nil
					if (v.text == "DBM Boss Kills/Wipes") then
						if (DBMloaded == false) then
							info.disabled = true
						end
					end
					info.text = v.text
					info.func = function()
						v.enabled = not v.enabled
						N_mUpdate();
					end
					info.checked = v.enabled
					UIDropDownMenu_AddButton(info)
				end
			end
		elseif (level == 2) then
			local info = UIDropDownMenu_CreateInfo();
			if UIDROPDOWNMENU_MENU_VALUE == "Example" then
			    info.text = "Foo"
			    UIDropDownMenu_AddButton(info, level)

			    info.text = "Bar"
			    UIDropDownMenu_AddButton(info, level)
			 end
		end
	end)
end


local isLoaded = false;
local throttle = false;
function Logger_OnEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11 = ...;
	local playerClass, englishClass = UnitClass("player");
	if (event == "PLAYER_LOGIN") then
		n_org = time();
		
		XP_start = UnitXP("player");
		XPMax = UnitXPMax("player");
		XPPercent = (XP_start / XPMax)*100;
		XPPercent = round(XPPercent, 2);
		if (UnitLevel("player") == 85) then
			n_store("Logged into |cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r (" .. GetRealmName() ..  "), level " .. UnitLevel("player") .. " |cFF" .. ns.n_colors[playerClass] .. playerClass .. "|r.");
		else
			n_store("Logged into |cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r (" .. GetRealmName() ..  "), level " .. UnitLevel("player") .. " |cFF" .. ns.n_colors[playerClass] .. playerClass .. "|r. EXP: " .. XPPercent .. "% (" .. XP_start .. "/" .. XPMax .. ").");
		end
		N_mUpdate();
	end
	if (event == "PLAYER_LEVEL_UP") then
		n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r leveled up to " .. arg1 .. ".");
		Screenshot();
		N_mUpdate()
	end;
	if (event == "ACHIEVEMENT_EARNED") then
		n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r earned the achievement " .. GetAchievementLink(arg1) .. ".");
		Screenshot();
		N_mUpdate();
	end;
	if (event == "PLAYER_DEAD") then
		if (UnitInBattleground("player") == nil) then
			n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r died.");
			N_mUpdate();
		end
	end;
	if (event == "ZONE_CHANGED_NEW_AREA") then
		throttle = false;
		n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r entered " .. GetZoneText() .. ".");
		N_mUpdate();
	end;
	if (event == "PLAYER_LOGOUT") then
		n_fin = time();
		n_sub = n_fin - n_org;		
		n_log[n_returnDailyIndex()]["tt"] = n_log[n_returnDailyIndex()]["tt"] + n_sub;
		n_sub = SecondsToClock(n_sub);
		local playerClass, englishClass = UnitClass("player");
		n_store("Logged out of |cFF" .. ns.n_colors[playerClass] .. "" ..  UnitName("player") .. "|r. Time played: " .. n_sub .. ".");
		N_mUpdate();
	end
	if (event == "ADDON_LOADED" and arg1 == "Logger") then
		isLoaded = true;
	end
	if (event == "LFG_COMPLETION_REWARD") then
		local _, _, _, textureFilename, _, _, _, _, _, _ = GetLFGCompletionReward();
		local lname, ltype, ldif, ldifn, lmax,_,_ = GetInstanceInfo();
		if (ltype == "party") then
			local ldifname = "";
			if (ldif == 1) then
				ldifname = "Normal";
			elseif (ldif == 2) then
				ldifname = "Heroic";
			end
			local homeArray = {}
			for i = 2, 5 do
				if (UnitExists("party" .. i) ~= nil) then
					local name, server = UnitName("party" .. i);
					if (name) then
						local f,_,_ = GetGuildInfo("party"..i);
						local p,_,_ = GetGuildInfo("player");
						local bn, bnom, ff = false, nil, false;
						for k=1, BNGetNumFriends() do
							for j=1, BNGetNumFriendToons(k) do
								local _, toonName, _, _, _, _, _, _, _, _, _, _, _ = BNGetFriendToonInfo(k, j)
								if (toonName == UnitName("party"..i)) then
									bn = true;
									local _,givenName,surname,_,_,_,_,_,_,_,_,_,_,_,_ = BNGetFriendInfo(k);
									bnom = format(BATTLENET_NAME_FORMAT, givenName, surname)
									break
								end
							end
							if (bn == true) then 
								break 
							end
						end
						local numf,_ = GetNumFriends();
						for k=1, numf do
							local nom,_,_,_,_,_,_,_ = GetFriendInfo(k);
							if (nom == UnitName("party"..i)) then
								ff = true;
								break
							end
						end
						if (f == p) then
							table.insert(homeArray, "|cFF" .. ns.n_colors[uClass] .. name .. "|r |cFF40FF40(G)|r");
						elseif (bn == true) then
							table.insert(homeArray, "|cFF" .. ns.n_colors[uClass] .. name .. "|r |cFF00FFF6(BN:" .. bnom ..")|r");
						elseif (ff == true) then
							table.insert(homeArray, "|cFF" .. ns.n_colors[uClass] .. name .. "|r |cFFFF80FF(F)|r");
						end
					end
				end
			end
			if (#homeArray ~= 0) then
				local sto = "|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r completed |TInterface\\LFGFrame\\LFGIcon-" .. textureFilename .. ":0|t" .. lname .. " (" .. ldifname .. ") with "
				for x, y in ipairs(homeArray) do
					if x < #homeArray and x ~= (#homeArray-1) then
						sto = sto .. y .. ", "
					end
					if x == (#homeArray-1) then
						sto = sto .. y .. ", and "
					end
					if x == #homeArray then
						sto = sto .. y .. "."
					end
				end
				n_store(sto);
			else
				n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r completed |TInterface\\LFGFrame\\LFGIcon-" .. textureFilename .. ":0|t" .. lname .. " (" .. ldifname .. ").");
			end
		elseif (ltype == "raid") then
			local ldifname = ldifn;
			local homeArray = {}
			for i = 1, GetNumRaidMembers() do
				if (UnitExists("raid" .. i) ~= nil) then
					local name, server = UnitName("raid" .. i);
					if (name) then
						local f,_,_ = GetGuildInfo("raid"..i);
						local p,_,_ = GetGuildInfo("player");
						local bn, bnom, ff = false, nil, false;
						for k=1, BNGetNumFriends() do
							for j=1, BNGetNumFriendToons(k) do
								local _, toonName, _, _, _, _, _, _, _, _, _, _, _ = BNGetFriendToonInfo(k, j)
								if (toonName == UnitName("raid"..i)) then
									bn = true;
									local _,givenName,surname,_,_,_,_,_,_,_,_,_,_,_,_ = BNGetFriendInfo(k);
									bnom = format(BATTLENET_NAME_FORMAT, givenName, surname)
									break
								end
							end
							if (bn == true) then 
								break 
							end
						end
						local numf,_ = GetNumFriends();
						for k=1, numf do
							local nom,_,_,_,_,_,_,_ = GetFriendInfo(k);
							if (nom == UnitName("raid"..i)) then
								ff = true;
								break
							end
						end
						if (f == p) then
							table.insert(homeArray, "|cFF" .. ns.n_colors[uClass] .. name .. "|r |cFF40FF40(G)|r");
						elseif (bn == true) then
							table.insert(homeArray, "|cFF" .. ns.n_colors[uClass] .. name .. "|r |cFF00FFF6(BN:" .. bnom ..")|r");
						elseif (ff == true) then
							table.insert(homeArray, "|cFF" .. ns.n_colors[uClass] .. name .. "|r |cFFFF80FF(F)|r");
						end
					end
				end
			end
			if (#homeArray ~= 0) then
				local sto = "|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r completed |TInterface\\LFGFrame\\LFGIcon-" .. textureFilename .. ":0|t" .. lname .. " (" .. ldifname .. ") with "
				for x, y in ipairs(homeArray) do
					if x < #v and x ~= (#v-1) then
						sto = sto .. y .. ", "
					end
					if x == (#v-1) then
						sto = sto .. y .. ", and "
					end
					if x == #v then
						sto = sto .. y .. "."
					end
				end
				n_store(sto);
			else
				n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r completed |TInterface\\LFGFrame\\LFGIcon-" .. textureFilename .. ":0|t" .. lname .. " (" .. ldifname .. ").");
			end
		end
	end
	if (event == "UPDATE_BATTLEFIELD_SCORE") then
		local battlefieldWinner = GetBattlefieldWinner();
		if (throttle == false) then
			if (battlefieldWinner ~= nil) then
				for i = 1, GetNumBattlefieldScores() do
					local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange, preMatchMMR, mmrChange, talentSpec = GetBattlefieldScore(i);
					if (name == UnitName("player")) then
						local pname, _, _, _, _,_,_ = GetInstanceInfo()
						local playerClass, englishClass = UnitClass("player");
						local fcolors = ""
						if (battlefieldWinner == 1) then
							fcolors = "|cFF00FFFF"
						elseif (battlefieldWinner == 0) then
							fcolors = "|cFF8B0000"
						else
							fcolors = ""
						end
						--print(pname);
						n_store("|cFF" .. ns.n_colors[playerClass] .. UnitName("player") .. "|r finished " .. "|T" .. ns.byName[pname]["icon"] .. ":0|t" ..  fcolors ..  pname .. "|r with " .. tostring(killingBlows) .. " killing blows, " .. tostring(honorableKills) .. " HKs, and " .. tostring(deaths) .. " deaths. Gained " .. tostring(honorGained) .. " honor. (|cFFDC143C" .. valShort(damageDone) .. "|rDD/|cFF7FFF00" .. valShort(healingDone) .. "|rHD)");
						throttle = true;
						break
					end
				end
			end
		end
	end
end

function SecondsToClock(sSeconds)
	if sSeconds == 0 then
		
	return "00:00:00";
	else
		nHours = string.format("%02.f", math.floor(sSeconds/3600));
		nMins = string.format("%02.f", math.floor(sSeconds/60 - (nHours*60)));
		nSecs = string.format("%02.f", math.floor(sSeconds - nHours*3600 - nMins *60));
		return nHours..":"..nMins..":"..nSecs
	end
end
local function len(t)
	local count = 0;
	for a, z in pairs(t) do
		count = count + 1;
	end
	return count;
end
function updateButtons(dex)
	_G["LoggerLogTab2"]:Enable();
	if (n_log[dex]["summary"]) then
		if (n_log[dex]["summary"]["levels"] ~= nil or n_log[dex]["summary"]["items"] ~= nil or n_log[dex]["summary"]["achieves"] ~= nil) then
			_G["LoggerLogTab2"]:Enable();
			if (n_log[dex]["summary"]["levels"] ~= nil) then
				Summary_Update("levels", dex);
				local classes = {}
				FillLocalizedClassList(classes, true)
				local toons = {}
				for j,k in pairs(n_log[dex]["summary"]["levels"]) do
					for a,z in pairs(ns.n_colors) do
						if (j:match(z)) then
							for l,s in pairs(classes) do
								if (s == a) then
									table.insert(toons,CLASS_ICON_TCOORDS[l])
								end
							end
						end
					end
				end
				local exum = math.random(1,#toons)
				_G["LoggerTestButton1"].icon:SetTexture("Interface\\\Glues\\CharacterCreate\\\UI-CharacterCreate-Classes");
				_G["LoggerTestButton1"].icon:SetTexCoord(toons[exum][1],toons[exum][2],toons[exum][3],toons[exum][4]);
				_G["LoggerTestButton1"]:Enable();
				_G["LoggerTestButton1Background"]:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal");
			else
				_G["LoggerTestButton1Background"]:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal-Desaturated");
				_G["LoggerTestButton1"].icon:SetTexture("");
				_G["LoggerTestButton1"]:Disable();
			end
			if (n_log[dex]["summary"]["items"] ~= nil) then
				local item;
				for j,k in pairs(n_log[dex]["summary"]["items"]) do
					if (type(k) ~= "number") then
						local exum = math.random(1,#k)
						local strr = string.match(k[exum],"|Hitem:%d+:");
						--local aID = string.sub(k[exum],startPos+7,endPos-1);
						local aID = string.match(strr,"%d+");
						item = tonumber(aID);
						break
					end
				end
				local _, _, _, _, _, _, _, _, _, img = GetItemInfo(item);
				if (img) then
					_G["LoggerTestButton2"].icon:SetTexture(img);
				else
					local _, _, icon, _, _, _, _, _, _ = GetSpellInfo(6603)
					_G["LoggerTestButton2"].icon:SetTexture(icon);
				end
				_G["LoggerTestButton2"]:Enable();
				_G["LoggerTestButton2Background"]:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal");
				Summary_Update("items", dex);
			else
				_G["LoggerTestButton2"].icon:SetTexture("");
				_G["LoggerTestButton2"]:Disable();
				_G["LoggerTestButton2Background"]:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal-Desaturated");
			end
			if (n_log[dex]["summary"]["achieves"] ~= nil) then
				Summary_Update("achieves", dex);
				local achievementId;
				for j,k in pairs(n_log[dex]["summary"]["achieves"]) do
					if (type(k) ~= "number") then
						local exum = math.random(1,#k)
						local strr = string.match(k[exum],"|Hachievement:%d+:");
						local aID = string.match(strr,"%d+");
						achievementId = tonumber(aID);
						break
					end
				end
				if (achievementId ~= nil) then
					local _, name, _, _, _, img, _, description, _, img = GetAchievementInfo(achievementId);
					_G["LoggerTestButton3"].icon:SetTexture(img);
				end
				_G["LoggerTestButton3"]:Enable();
				_G["LoggerTestButton3Background"]:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal");
			else
				_G["LoggerTestButton3"].icon:SetTexture("");
				_G["LoggerTestButton3"]:Disable();
				_G["LoggerTestButton3Background"]:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal-Desaturated");
			end
		else
			_G["LoggerLogTab2"]:Disable();
		end
	else
		_G["LoggerLogTab2"]:Disable();
	end
	n_scroll:Show();
	_G["LoggerLogTab1"].Highlight:Hide();
	_G["LoggerLogTab2"].Highlight:Hide();
	n_summary:Hide();
	-- n_scroll:Show();
	-- n_summary:Hide();
end
function N_mUpdate()
	shownDateIndex = n_returnDailyIndex();
	ns.displayIndex = n_returnDailyIndex();
	textArea:SetText("");
	str = "";
	for index,value in ipairs(n_log[n_returnDailyIndex()]) do
		if ((string.find(n_log[n_returnDailyIndex()][index], "died") ~= nil and n_Settings.death.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "Logged into") ~= nil and n_Settings.login.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "earned the") ~= nil and n_Settings.achievement.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "Logged out") ~= nil and n_Settings.logout.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "leveled") ~= nil and n_Settings.levelup.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "entered") ~= nil and n_Settings.zone.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "killed") ~= nil and n_Settings.DBM.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "wiped") ~= nil and n_Settings.DBM.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "finished") ~= nil and n_Settings.battleground.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "completed") ~= nil and n_Settings.dungeons.enabled == true)) then
			n_ddt = string.sub(value, 1, 22);
			n_pdt = string.sub(value, 23);
			str = str .. "|cFF6495ED" .. n_ddt .. ":|r " .. n_pdt .. "\n"
		end
	end
	local acq = "Today, ";
	local dex = n_returnDailyIndex();
	if (n_log[dex]["items"] ~= nil) then
		local playerTable = {}
		for p, v in ipairs(n_log[dex]["items"]) do
			if (playerTable[v["player"]] == nil) then
				playerTable[v["player"]] = {};
			end
			table.insert(playerTable[v["player"]], v["link"]);
		end
		local pre_str = ""
		local plen = n_tlen(playerTable);
		local stringTable = {}
		for p, v in pairs(playerTable) do
			pre_str = p .. " obtained "
			for x, y in ipairs(v) do
				if x < #v and x ~= (#v-1) then
					pre_str = pre_str .. y .. "|cFFFFD700,|r "
				end
				if x == (#v-1) then
					pre_str = pre_str .. y .. "|cFFFFD700, and|r "
				end
				if x == #v then
					pre_str = pre_str .. y
				end
			end
			table.insert(stringTable, pre_str)
		end
		for p, v in ipairs(stringTable) do
			if p < #stringTable and p ~= (#stringTable-1) then
				acq = acq .. stringTable[p] .. "|cFFFFD700; |r";
			end
			if p < #stringTable and p ~= (#stringTable-1) then
				acq = acq .. stringTable[p] .. "|cFFFFD700; while|r";
			end
			if p == #stringTable then
				acq = acq .. stringTable[p] .. "|cFFFFD700.|r"
			end
		end
		str = str .. "\n |cFFFFD700" .. acq .. "|r\n";
	end
	local apd = "";
	if (tonumber(string.sub(ns.n_date,4,5)) == 1 or tonumber(string.sub(ns.n_date,4,5)) == 21 or tonumber(string.sub(ns.n_date,4,5)) == 31) then
		apd = "st"
	elseif (tonumber(string.sub(ns.n_date,4,5)) == 2 or tonumber(string.sub(ns.n_date,4,5)) == 22) then
		apd = "nd"
	elseif (tonumber(string.sub(ns.n_date,4,5)) == 3 or tonumber(string.sub(ns.n_date,4,5)) == 23) then
		apd = "rd"
	elseif ((tonumber(string.sub(ns.n_date,4,5)) >= 4 and tonumber(string.sub(ns.n_date,4,5)) <= 20) or (tonumber(string.sub(ns.n_date,4,5)) >= 24 and tonumber(string.sub(ns.n_date,4,5)) <= 30)) then
		apd = "th"
	end
	asda:SetText(ns.months[tonumber(string.sub(ns.n_date,1,2))] .. " " .. tostring(tonumber(string.sub(ns.n_date,4,5))) .. apd .. ", 20" .. string.sub(ns.n_date,7,8));
	textArea:SetText(str);
	--N_Scroll:SetMinMaxValues(1, # n_log[ns.n_date])
	n_scroll:UpdateScrollChildRect();
	n_scroll:SetVerticalScroll(n_scroll:GetVerticalScrollRange());
	ns.numshown = 0;
	for w in string.gmatch(str, "\n") do
      ns.numshown = ns.numshown + 1;
    end
	shownDateIndex = dex;
	n_createDrop()
	-----------------------Update buttons
	updateButtons(shownDateIndex)
end

function N_sUpdate(sdate)
	textArea:SetText("");
	str = "";
	local dex = 0;
	for index,value in pairs(n_log) do 
		if (value["date"] == sdate) then
			dex = index;
		end
	end
	shownDateIndex = dex;
	for index,value in ipairs(n_log[dex]) do 
		if ((string.find(value, "died") ~= nil and n_Settings.death.enabled == true) or (string.find(value, "Logged into") ~= nil and n_Settings.login.enabled == true) or (string.find(value, "earned the") ~= nil and n_Settings.achievement.enabled == true) or (string.find(value, "Logged out") ~= nil and n_Settings.logout.enabled == true) or (string.find(value, "leveled") ~= nil and n_Settings.levelup.enabled == true) or (string.find(value, "entered") ~= nil and n_Settings.zone.enabled == true) or (string.find(value, "killed") ~= nil and n_Settings.DBM.enabled == true) or (string.find(value, "wiped") ~= nil and n_Settings.DBM.enabled == true) or (string.find(value, "finished") ~= nil and n_Settings.battleground.enabled == true) or (string.find(value, "completed") ~= nil and n_Settings.dungeons.enabled == true)) then
			n_ddt = string.sub(value, 1, 22);
			n_pdt = string.sub(value, 23);
			str = str .. "|cFF6495ED" .. n_ddt .. ":|r " .. n_pdt .. "\n"
		end
		--textArea:AddMessage("|cFF6495ED" .. n_ddt .. ":|r " .. n_pdt);
	end
	local acq = "Today, ";
	if (n_log[dex]["items"] ~= nil) then
		local playerTable = {}
		for p, v in ipairs(n_log[dex]["items"]) do
			if (playerTable[v["player"]] == nil) then
				playerTable[v["player"]] = {};
			end
			table.insert(playerTable[v["player"]], v["link"]);
		end
		local pre_str = ""
		local plen = n_tlen(playerTable);
		local stringTable = {}
		for p, v in pairs(playerTable) do
			pre_str = p .. " obtained "
			for x, y in ipairs(v) do
				if x < #v and x ~= (#v-1) then
					pre_str = pre_str .. y .. "|cFFFFD700,|r "
				end
				if x == (#v-1) then
					pre_str = pre_str .. y .. "|cFFFFD700, and|r "
				end
				if x == #v then
					pre_str = pre_str .. y
				end
			end
			table.insert(stringTable, pre_str)
		end
		for p, v in ipairs(stringTable) do
			if p < #stringTable and p ~= (#stringTable-1) then
				acq = acq .. stringTable[p] .. "|cFFFFD700; |r";
			end
			if p < #stringTable and p ~= (#stringTable-1) then
				acq = acq .. stringTable[p] .. "|cFFFFD700; while|r";
			end
			if p == #stringTable then
				acq = acq .. stringTable[p] .. "|cFFFFD700.|r"
			end
		end
		str = str .. "\n |cFFFFD700" .. acq .. "|r\n";
	end
	n_sub = SecondsToClock(n_log[dex]["tt"]);
	n_tim:SetText("Time played: |cFFFFFFFF" .. n_sub .. "|r");
	g:SetWidth(160)
	maxScroll = n_scroll:GetVerticalScrollRange();
	n_scroll:SetVerticalScroll(maxScroll);
	textArea:SetText(str);
	n_scroll:UpdateScrollChildRect();
	n_scroll:SetVerticalScroll(n_scroll:GetVerticalScrollRange());
	local apd = "";
	if (tonumber(string.sub(n_log[dex]["date"],4,5)) == 1 or tonumber(string.sub(n_log[dex]["date"],4,5)) == 21 or tonumber(string.sub(n_log[dex]["date"],4,5)) == 31) then
		apd = "st"
	elseif (tonumber(string.sub(n_log[dex]["date"],4,5)) == 2 or tonumber(string.sub(n_log[dex]["date"],4,5)) == 22) then
		apd = "nd"
	elseif (tonumber(string.sub(n_log[dex]["date"],4,5)) == 3 or tonumber(string.sub(n_log[dex]["date"],4,5)) == 23) then
		apd = "rd"
	elseif ((tonumber(string.sub(n_log[dex]["date"],4,5)) >= 4 and tonumber(string.sub(n_log[dex]["date"],4,5)) <= 20) or (tonumber(string.sub(n_log[dex]["date"],4,5)) >= 24 and tonumber(string.sub(n_log[dex]["date"],4,5)) <= 30)) then
		apd = "th"
	end
	asda:SetText(ns.months[tonumber(string.sub(n_log[dex]["date"],1,2))] .. " " .. tostring(tonumber(string.sub(n_log[dex]["date"],4,5))) .. apd .. ", 20" .. string.sub(n_log[dex]["date"],7,8));
	ns.numshown = 0;
	for w in string.gmatch(str, "\n") do
      ns.numshown = ns.numshown + 1;
    end
	ns.displayIndex = dex
	n_createDrop()
	updateButtons(dex)
end;


function N_loadAll()
	textArea:SetText("");
	--textArea:Clear();
	str = "";
	for index,value in ipairs(n_log[n_returnDailyIndex()]) do 
		if ((string.find(n_log[n_returnDailyIndex()][index], "died") ~= nil and n_Settings.death.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "Logged into") ~= nil and n_Settings.login.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "earned the") ~= nil and n_Settings.achievement.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "Logged out") ~= nil and n_Settings.logout.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "leveled") ~= nil and n_Settings.levelup.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "entered") ~= nil and n_Settings.zone.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "killed") ~= nil and n_Settings.DBM.enabled == true) or (string.find(n_log[n_returnDailyIndex()][index], "wiped") ~= nil and n_Settings.DBM.enabled == true)) then
			n_ddt = string.sub(value, 1, 22);
			n_pdt = string.sub(value, 23);
			str = str .. "|cFF6495ED" .. n_ddt .. ":|r " .. n_pdt .. "\n"
		end
		--textArea:AddMessage("|cFF6495ED" .. n_ddt .. ":|r " .. n_pdt);
	end
	textArea:SetText(str);
	n_scroll:UpdateScrollChildRect();
	n_scroll:SetVerticalScroll(n_scroll:GetVerticalScrollRange());
	ns.numshown = 0;
	for w in string.gmatch(str, "\n") do
      ns.numshown = ns.numshown + 1;
    end
end;



function n_store(text)
	local waitTab = {}
	ReturnDate();
	ReturnTime();
	
	if (isLoaded == false) then
		table.insert(waitTab,ns.n_date .. " " .. n_time .. " " .. text);
	else
		if (isLoaded == true) then
			local num = n_returnDailyIndex();
			if (#waitTab > 0) then
				for p, v in ipairs(waitTab) do
					table.insert(n_log[n_returnDailyIndex()],v);
				end
			end
			table.insert(n_log[num],ns.n_date .. " " .. n_time .. " " .. text);
		end
	end
end;



local CharTabtable = {};
CharacterFrame_TabBoundsCheck = nil
function CharacterFrame_TabBoundsCheck(self)
	if ( string.sub(self:GetName(), 1, 17) ~= "CharacterFrameTab" ) then
		return;
	end
	
	local totalSize = 60
	local previouslyshowntab = CharacterFrameTab1
	for i=1, CharacterFrame.numTabs do
		_G["CharacterFrameTab"..i.."Text"]:SetWidth(0)
		PanelTemplates_TabResize(_G["CharacterFrameTab"..i], 0)
		if i>1 then
			_G["CharacterFrameTab"..i]:SetPoint( "LEFT", previouslyshowntab, "RIGHT", -15, 0 )
		end
		if _G["CharacterFrameTab"..i]:IsShown() then
			previouslyshowntab =  _G["CharacterFrameTab"..i]
			totalSize = totalSize + previouslyshowntab:GetWidth()
		end
	end

	if n_tn then
		if not CharacterFrameTab4:IsShown() then
			if not CharacterFrameTab3:IsShown() then
				if not CharacterFrameTab2:IsShown() then
					_G[n_tn]:SetPoint( "LEFT", "CharacterFrameTab1", "RIGHT", -15, 0 )
				else
					_G[n_tn]:SetPoint( "LEFT", "CharacterFrameTab2", "RIGHT", -15, 0 )
				end
			else
				_G[n_tn]:SetPoint( "LEFT", "CharacterFrameTab3", "RIGHT", -15, 0 )
			end
		else
			_G[n_tn]:SetPoint( "LEFT", "CharacterFrameTab4", "RIGHT", -15, 0 )
		end
	end
	
	local threshold = 435
	local diff = totalSize - threshold
	local Chartabtable = {};
	if ( totalSize > threshold ) then
		--Find the biggest tab
		local bigi = 0;
		local bign = 0;
		for i=1, CharacterFrame.numTabs do
			CharTabtable[i]=_G["CharacterFrameTab"..i];
			if (_G["CharacterFrameTab"..i]:GetWidth() > bign) then
				bigi = i;
				bign = _G["CharacterFrameTab"..i]:GetWidth();
			end
		end
		--table.sort(CharTabtable, CompareFrameSize);
		
		local i=1;
		while ( diff > 0 and i <= CharacterFrame.numTabs) do
			local tabText = _G[CharTabtable[i]:GetName().."Text"]
			local change = min(10, diff);
			tabText:SetWidth(tabText:GetWidth() - change);
			diff = diff - change;
			PanelTemplates_TabResize(CharTabtable[i], -change, nil, 8-change, 88);
			i = i+1;
		end
	end
end

-- function n_getmonth(month)
	-- local ns.months = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" }
	-- return ns.months[tonumber(month)]
-- end
-- function n_get_formatted_date_parts(date_str, date_format)
	-- local d,m,y, arr, x, yy, mm, dd, use_month_names
	-- local ns.months = { jan=1, feb=2, mar=3, apr=4, may=5, jun=6, jul=7, aug=8, sep=9, oct=10, nov=11, dec=12 }

	-- if (date_format) then
	
		-- if string.find(date_format, "mmm") then
			-- use_month_names = true
		-- else
			-- use_month_names = false
		-- end

		-- d = string.find(date_format, "dd")
		-- m = string.find(date_format, "mm")
		-- y = string.find(date_format, "yy")
		
		-- arr = { { pos=y, b="yy" }, { pos=m, b="mm" } , { pos=d, b="dd" }  }
		-- arr = table_sort(arr, "pos")

		-- date_format = string.gsub(date_format,"yyyy","(%%d+)")
		-- date_format = string.gsub(date_format,"mmm","(%%a+)")
		-- date_format = string.gsub(date_format,"yy","(%%d+)")
		-- date_format = string.gsub(date_format,"mm","(%%d+)")
		-- date_format = string.gsub(date_format,"dd","(%%d+)")
		-- date_format = string.gsub(date_format," ","%%s")
	-- else
		-- date_format = "(%d+)-(%d+)-(%d+)"
		-- arr = { { pos=1, b="yy" }, { pos=2, b="mm" } , { pos=3, b="dd" }  }
	-- end

	-- if (date_str and date_str~="") then		
		-- _, _, arr[1].c, arr[2].c, arr[3].c = string.find(string.lower(date_str), date_format)
	-- else
		-- return nil, nil, nil
	-- end


	-- arr = lua_sort(arr, "b")
	-- yy = arr[3].c
	-- mm = arr[2].c
	-- dd = arr[1].c

	-- if (use_month_names) then		
	
		-- mm = ns.months[lower(string.sub(mm,1,3))]
		-- if (not mm) then
			-- error("Invalid month name.")
		-- end
	-- end

	-- -- for naughty people who still use two digit years.

	-- if (string.len(yy)==2) then
		-- if (tonumber(yy)>40) then
			-- yy = "19"..yy
		-- else
			-- yy = "20"..yy
		-- end
	-- end

	-- return tonumber(yy),tonumber(mm),tonumber(dd)
-- end
function n_tlen(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--3344
-- function ChatFrame_OnHyperlinkShow(self, link, text, button)
	-- SetItemRef(link, text, button, self);
-- end